local suit = require 'SUIT'


local function draw_window(w, title)
	w.ui:registerDraw(love.graphics.setColor, 128,128,128)
	w.ui:registerDraw(love.graphics.rectangle, 'fill', w.x-1, w.y-1, w.w+2, w.h+2)
	w.ui:registerDraw(love.graphics.setColor, 30,30,30)
	w.ui:registerDraw(love.graphics.rectangle, 'fill', w.x, w.y, w.w, w.h)

	w.ui.layout:reset(w.x,w.y)
	w.active = false
	if w.ui:isActive(w.ui:Button(title, {align='left'}, w.ui.layout:row(w.w, 20)).id) then
		local mx,my = w.ui:getMousePosition()
		local dx,dy = mx - w.mouse_last[1], my - w.mouse_last[2]
		w.x, w.y = w.x + dx, w.y + dy
		w.active = true
	end
	w.mouse_last = {w.ui:getMousePosition()}

	w.ui.layout:reset(w.x+5,w.y+25)

	return w.ui
end

local slider = {value = 0.5}
function love.load()
	windows = {
		{ui = suit.new(), x = 10, y = 10, w = 300, h = 300, mouse_last = {0,0}},
		{ui = suit.new(), x = 320, y = 10, w = 300, h = 400, mouse_last = {0,0}}
	}

	windows[1].update = function(self)
		local ui = draw_window(self, "Window 1")
		ui:Button("Hello, World!", ui.layout:row(200,30))
		ui:Slider(slider, ui.layout:row(200, 20))
	end

	windows[2].update = function(self)
		local ui = draw_window(self, "Window 2")
		ui:Button("Hello from window 2", ui.layout:row(200, 30))
		ui:Slider(slider, ui.layout:row(200, 20))
	end
end

function love.update()
	local front
	for i, win in ipairs(windows) do
		win:update()
		if win.active then front = i end
	end
	if front then
		table.insert(windows, table.remove(windows, front))
	end
end

function love.draw()
	for _, win in ipairs(windows) do
		win.ui:draw()
	end
end
